<?php
/**
Functions for Ship-Quik
 **/

namespace ShipQuik\Shared;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}

namespace ShipQuik\Shared;

class ShipQuik_OrdersPaid
{
    private static $_instance = null;

    protected $parent;

    protected $clientId;

    protected $references;

    protected $config;

    protected $data;

    public function __construct($parent = null, $clientId, $references)
    {
        $this->parent = $parent;
        $this->clientId = $clientId;
        $this->references = $references;

        $this->config = $parent->config;

        $this->data = $this->getData($clientId, $references);
    }

    private function getData()
    {
        $ordersPaid = [];

        $ordersPaid['clientId'] = $this->clientId;
        $ordersPaid['references'] = $this->references;

        return $ordersPaid;
    }

    public function send()
    {
        $result = false;

        $params = [];

        $params['Baseurl'] = $this->config->getValueByKey('endpoints')['getOrdersPaid'];
        $params['Data'] = $this->data;

        // d(json_encode($params['Data']));

        $curl = new ShipQuik_API($this->parent, $params, true);
        $result = $curl->runCall();

        if ($result == 'renew_token') {
            $this->config->reNewAccessToken();
            $result = $curl->runCall();
        }

        return $result;
    }

    public static function instance()
    {
        if (!isset(self::$_instance)) {
            $class = __CLASS__;
            self::$_instance = new $class();
        }

        return self::$_instance;
    }

    public function __clone()
    {
        trigger_error('La clonación de este objeto no está permitida', E_USER_ERROR);
    }
}
