<?php
/**
Functions for Ship-Quik
 **/

namespace ShipQuik\Shared;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}

use ShipQuik\WooCommerce\ShipQuik_Shipments;

class ShipQuik_PickupDate
{
    private static $_instance = null;

    protected $parent;

    protected $mydate;

    protected $config;

    protected $data;

    public function __construct($parent = null, $mydate)
    {
        $this->parent = $parent;
        $this->mydate = $mydate;

        $this->config = $parent->config;

        $this->data = $this->getData($mydate);
    }

    private function getData()
    {
        $pickupDate = [];

        $senderAddress = ShipQuik_Shipments::getSenderAddress($this->config);

        $pickupDate['pickupDate'] = $this->mydate;

        $pickupDate['shipment']['countryCodeOrigin'] = $senderAddress['CountryCode'];
        $pickupDate['shipment']['originAddress']['city'] = $senderAddress['City'];
        $pickupDate['shipment']['originAddress']['postalCode'] = $senderAddress['PostalCode'];

        return $pickupDate;
    }

    public function send()
    {
        $result = false;

        $params = [];

        $params['Baseurl'] = $this->config->getValueByKey('endpoints')['pickupDate'];
        $params['Data'] = $this->data;

        // d(json_encode($params['Data']));

        $curl = new ShipQuik_API($this->parent, $params, true);
        $result = $curl->runCall();

        if ($result == 'renew_token') {
            $this->config->reNewAccessToken();
            $result = $curl->runCall();
        }

        return $result;
    }

    public static function instance()
    {
        if (!isset(self::$_instance)) {
            $class = __CLASS__;
            self::$_instance = new $class();
        }

        return self::$_instance;
    }

    public function __clone()
    {
        trigger_error('La clonación de este objeto no está permitida', E_USER_ERROR);
    }
}
