<?php
/**
Functions for Ship-Quik
 **/

namespace ShipQuik\Shared;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}

use \ShipQuik\Shared\ShipQuik_API;

class ShipQuik_ShippingTaxes
{
    private static $_instance = null;

    protected $parent;

    protected $taxesInfo;

    protected $config;

    protected $data;

    public function __construct($parent = null, $taxesInfo = [])
    {
        $this->parent = $parent;
        $this->taxesInfo = $taxesInfo;

        $this->config = $parent->config;

        $this->data = $this->getData($taxesInfo);
    }

    private function getData($taxesInfo)
    {
        $taxesData = [];

        $taxesData['countryCodeOrigin']      = $taxesInfo['countryCodeOrigin'];
        $taxesData['countryCodeDestination'] = $taxesInfo['countryCodeDestination'];
        $taxesData['postalCodeOrigin']       = $taxesInfo['postalCodeOrigin'];
        $taxesData['postalCodeDestination']  = $taxesInfo['postalCodeDestination'];
        $taxesData['idUser']                 = $taxesInfo['idUser'];

        return $taxesData;
    }

    public function send()
    {
        $result = false;

        $params = [];
        $params['Baseurl']  = $this->config->getValueByKey('endpoints')['getIvaCountryUser'];
        $params['Data']     = $this->data;

        // d(json_encode($params['Data']));

        $curl = new ShipQuik_API($this->parent, $params, true);
        $result = $curl->runCall();

        if ($result == "renew_token") {
            $this->config->reNewAccessToken();

            $result = $curl->runCall();
        }

        if ($result) {
            if (isset($result['ivaInfo'])) {
                return $result;
            }
        }

        return false;
    }

    public static function instance()
    {
        if (! isset(self::$_instance)) {
            $class = __CLASS__;
            self::$_instance = new $class();
        }
        return self::$_instance;
    }

    public function __clone()
    {
        trigger_error('La clonación de este objeto no está permitida', E_USER_ERROR);
    }
}
